﻿// Spore API Sample
// www.sporeapi.com
package {
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.text.*;
	import flash.geom.*;
	
	// This example uses the Get Fishs For SporeCast service
	//      http://www.spore.com/rest/assets/sporecast/<SporeCastId>/<StartIndex>/<Length>

		public class SporeWebTest extends MovieClip {  	
		
		
		public var mServerString:String = "http://www.spore.com";
		public var mTextHolder:TextHolder;
		public var mTextField:TextField;
		
		public var mStartIndex:Number;
		public var mCount:Number = 10;
		

		public var mRock2s:Array = new Array();
		public var mRocks:Array = new Array();
		public var mCastles:Array = new Array();
		public var mFishs:Array = new Array();
		public var mStarfishlefts:Array = new Array();
		public var mStarfishrights:Array = new Array();
		public var mBigfishs:Array = new Array();
		public var mFeeders:Array = new Array();
		public var mSubmarines:Array = new Array();
		public var mHoverers:Array = new Array();
		
		public var mRock2sloaded:Boolean = false;
		public var mRocksloaded:Boolean = false;
		public var mCastlesloaded:Boolean = false;
		public var mFishsloaded:Boolean = false;
		public var mStarfishleftsloaded:Boolean = false;
		public var mStarfishrightsloaded:Boolean = false;
		public var mBigfishsloaded:Boolean = false;
		public var mFeedersloaded:Boolean = false;
		public var mSubmarinesloaded:Boolean = false;
		public var mHoverersloaded:Boolean = false;
		
		
		var newRock2layer:Layer = new Layer;
		var newRocklayer:Layer = new Layer;
		var newCastlelayer:Layer = new Layer;
		var newSubmarinelayer:Layer = new Layer;
		var newHovererlayer:Layer = new Layer;
		var newStarfishleftlayer:Layer = new Layer;
		var newStarfishrightlayer:Layer = new Layer;
		var newBigfishlayer:Layer = new Layer;
		var newFishslayer:Layer = new Layer;
		var newFeederlayer:Layer = new Layer;
		
		public var mId:String;
		public var mWidth = 300;
		public var mWidthrock2 = 200;
		public var mWidthrock = 200;
		public var mWidthfeeder =375;
		public var mWidthcastle = 400;
		public var mWidthhoverer = 375;
		public var mWidthbigfish = 200;
		public var mWidthfish = 415;
		public var mHeight = 475;
		public var mHeighthoverer = 200;
		
		public function SporeWebTest()
		{
			// Put a text field on the stage			
			mTextHolder = new TextHolder();
			mTextField = mTextHolder.getChildByName("mTextField") as TextField;
			addChild(mTextHolder);
			
			//var button = getChildByName("SwapFishButton") as Swapfishbutton;
			mSwapFishButton.mApp = this;
				


			
			
			
	
//	Desired layer order from back to front
//	
//	Rock2
//	Castle
//	Rock
//	Submarine
//	Hoverer
//	BigFish
//Starflishleft
//Starfishright
//	Fish
//	Feeder
		

			addChild(newSubmarinelayer)
			addChild(newRock2layer)
			addChild(newRocklayer)
			addChild(newStarfishleftlayer)
			addChild(newStarfishrightlayer)
			addChild(newCastlelayer)
			addChild(newBigfishlayer)
			addChild(newHovererlayer)
			addChild(newFishslayer)
			addChild(newFeederlayer)	
	
			GetRock2sForSporecast("500275436790", 0, 5);
			GetCastlesForSporecast("500273616369", 0, 1);
			GetRocksForSporecast("500273594146", 0, 3);
			GetSubmarinesForSporecast("500273617213", 0, 1);
			GetHoverersForSporecast("500273608125", 0, 1);
			GetStarfishleftsForSporecast("500276502338", 0, 1);
			GetStarfishrightsForSporecast("500276502338", 0, 1);
			GetBigfishsForSporecast("500275438491", 0, 1);
			GetFishsForSporecast("500273571150", 0, 3);
			GetFeedersForSporecast("500273595289", 0, 1);

			addEventListener(Event.ENTER_FRAME, UpdatePNGloader);
			addEventListener(Event.ENTER_FRAME, CheckIfSporecastsLoaded);
//          addEventListener(Event.ENTER_FRAME, UpdateRock2);
//			addEventListener(Event.ENTER_FRAME, UpdateCastle);
//			addEventListener(Event.ENTER_FRAME, UpdateRock);
//			addEventListener(Event.ENTER_FRAME, UpdateSubmarine);
//			addEventListener(Event.ENTER_FRAME, UpdateHoverer);
//			addEventListener(Event.ENTER_FRAME, UpdateStarfishleft);
//			addEventListener(Event.ENTER_FRAME, UpdateStarfishright);
//			addEventListener(Event.ENTER_FRAME, UpdateBigfish);
//			addEventListener(Event.ENTER_FRAME, UpdateFish);
//			addEventListener(Event.ENTER_FRAME, UpdateFeeder);


		}
		public function GetRock2sForSporecast(id:String, startIndex:Number, numBuddies:Number):void
		{
			mId = id;
			mStartIndex = startIndex;
			var queryString:String = mServerString + "/rest/assets/sporecast/" + id + "/" + startIndex + "/" + 1000;
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, GotRock2s);
			loader.addEventListener(IOErrorEvent.IO_ERROR, HandleError);
			loader.load(new URLRequest(queryString));			
			mTextField.text = "Loading query \n" + queryString;
		}
		public function GetCastlesForSporecast(id:String, startIndex:Number, numBuddies:Number):void
		{
			mId = id;
			mStartIndex = startIndex;
			var queryString:String = mServerString + "/rest/assets/sporecast/" + id + "/" + startIndex + "/" + 1000;
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, GotCastles);
			loader.addEventListener(IOErrorEvent.IO_ERROR, HandleError);
			loader.load(new URLRequest(queryString));			
			mTextField.text = "Loading query \n" + queryString;
		}
		public function GetRocksForSporecast(id:String, startIndex:Number, numBuddies:Number):void
		{
			mId = id;
			mStartIndex = startIndex;
			var queryString:String = mServerString + "/rest/assets/sporecast/" + id + "/" + startIndex + "/" + 1000;
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, GotRocks);
			loader.addEventListener(IOErrorEvent.IO_ERROR, HandleError);
			loader.load(new URLRequest(queryString));			
			mTextField.text = "Loading query \n" + queryString;
		}

		public function GetSubmarinesForSporecast(id:String, startIndex:Number, numBuddies:Number):void
		{
			mId = id;
			mStartIndex = startIndex;
			var queryString:String = mServerString + "/rest/assets/sporecast/" + id + "/" + startIndex + "/" + 1000;
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, GotSubmarines);
			loader.addEventListener(IOErrorEvent.IO_ERROR, HandleError);
			loader.load(new URLRequest(queryString));			
			mTextField.text = "Loading query \n" + queryString;
		}
		public function GetHoverersForSporecast(id:String, startIndex:Number, numBuddies:Number):void
		{
			mId = id;
			mStartIndex = startIndex;
			var queryString:String = mServerString + "/rest/assets/sporecast/" + id + "/" + startIndex + "/" + 1000;
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, GotHoverers);
			loader.addEventListener(IOErrorEvent.IO_ERROR, HandleError);
			loader.load(new URLRequest(queryString));			
			mTextField.text = "Loading query \n" + queryString;
		}
		public function GetStarfishleftsForSporecast(id:String, startIndex:Number, numBuddies:Number):void
		{
			mId = id;
			mStartIndex = startIndex;
			var queryString:String = mServerString + "/rest/assets/sporecast/" + id + "/" + startIndex + "/" + 1000;
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, GotStarfishlefts);
			loader.addEventListener(IOErrorEvent.IO_ERROR, HandleError);
			loader.load(new URLRequest(queryString));			
			mTextField.text = "Loading query \n" + queryString;
		}
		public function GetStarfishrightsForSporecast(id:String, startIndex:Number, numBuddies:Number):void
		{
			mId = id;
			mStartIndex = startIndex;
			var queryString:String = mServerString + "/rest/assets/sporecast/" + id + "/" + startIndex + "/" + 1000;
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, GotStarfishrights);
			loader.addEventListener(IOErrorEvent.IO_ERROR, HandleError);
			loader.load(new URLRequest(queryString));			
			mTextField.text = "Loading query \n" + queryString;
		}
		public function GetBigfishsForSporecast(id:String, startIndex:Number, numBuddies:Number):void
		{
			mId = id;
			mStartIndex = startIndex;
			var queryString:String = mServerString + "/rest/assets/sporecast/" + id + "/" + startIndex + "/" + 1000;
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, GotBigfishs);
			loader.addEventListener(IOErrorEvent.IO_ERROR, HandleError);
			loader.load(new URLRequest(queryString));			
			mTextField.text = "Loading query \n" + queryString;
		}
		public function GetFishsForSporecast(id:String, startIndex:Number, numBuddies:Number):void
		{
			mId = id;
			mStartIndex = startIndex;
			var queryString:String = mServerString + "/rest/assets/sporecast/" + id + "/" + startIndex + "/" + 1000;
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, GotFishs);
			loader.addEventListener(IOErrorEvent.IO_ERROR, HandleError);
			loader.load(new URLRequest(queryString));			
			mTextField.text = "Loading query \n" + queryString;
		}
		public function GetFeedersForSporecast(id:String, startIndex:Number, numBuddies:Number):void
		{
			mId = id;
			mStartIndex = startIndex;
			var queryString:String = mServerString + "/rest/assets/sporecast/" + id + "/" + startIndex + "/" + 1000;
			var loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, GotFeeders);
			loader.addEventListener(IOErrorEvent.IO_ERROR, HandleError);
			loader.load(new URLRequest(queryString));			
			mTextField.text = "Loading query \n" + queryString;
		}
		
				
		
		public function HandleError(e:IOErrorEvent): void
		{
			mTextField.text = e.text;
		}
		public function GotRock2s(e:Event):void
		{
			var dataXML:XML = new XML(e.target.data);
			
			// Parse the XML
			namespace atomenv = "http://www.w3.org/2005/Atom";
			use namespace atomenv;
			
			for each (var assetXML:XML in dataXML..asset)
			{
				var assetId:String = assetXML..id.toString();
				var spawnPoint:Point = new Point(Math.random() * mWidthrock2 + 275, 155);
				var newRock2:Rock2 = new Rock2(this, assetId, spawnPoint, Math.random() * 2.0 + 0.4);
				mRock2s.push(newRock2);
//				newRock2layer.addChild(newRock2);
			}
			mTextField.text = ""
			mRock2sloaded = true
			
			//for(var i = 0; i < 3; i++)
//			{
//			var	newindex = Math.floor(mRock2s.length * Math.random())
//			newRock2layer.addChild (mRock2s [newindex]) 
//			mPNGsToLoad.push(mRock2s [newindex]);
//			
//			}


		}		
		public function GotCastles(e:Event):void
		{
			var dataXML:XML = new XML(e.target.data);
			
			// Parse the XML
			namespace atomenv = "http://www.w3.org/2005/Atom";
			use namespace atomenv;
			
			for each (var assetXML:XML in dataXML..asset)
			{
				var assetId:String = assetXML..id.toString();
				var spawnPoint:Point = new Point(362, 165);
				var newCastle:Castle = new Castle(this, assetId, spawnPoint, Math.random() * 2.0 + 0.4);
				mCastles.push(newCastle);			
//				newCastlelayer.addChild(newCastle); 
			}
			mTextField.text = ""
			mCastlesloaded = true

//			for(var i = 0; i < 1; i++)
//			{
//			var	newindex = Math.floor(mCastles.length * Math.random())
//			newCastlelayer.addChild (mCastles [newindex]) 
//			}

		}
		public function GotRocks(e:Event):void
		{
			var dataXML:XML = new XML(e.target.data);
			
			// Parse the XML
			namespace atomenv = "http://www.w3.org/2005/Atom";
			use namespace atomenv;
			
			for each (var assetXML:XML in dataXML..asset)
			{
				var assetId:String = assetXML..id.toString();
				var spawnPoint:Point = new Point(Math.random() * mWidthrock + 180, 280);
				var newRock:Rock = new Rock(this, assetId, spawnPoint, Math.random() * 2.0 + 0.4);
				mRocks.push(newRock);			
//				newRocklayer.addChild(newRock);
				}
			mTextField.text = ""
			mRocksloaded = true
//
//			for(var i = 0; i < 3; i++)
//			{
//			var	newindex = Math.floor(mRocks.length * Math.random())
//			newRocklayer.addChild (mRocks [newindex]) 
//			}

		}		

			public function GotSubmarines(e:Event):void
		{
			var dataXML:XML = new XML(e.target.data);
			
			// Parse the XML
			namespace atomenv = "http://www.w3.org/2005/Atom";
			use namespace atomenv;
			
			for each (var assetXML:XML in dataXML..asset)
			{
				var assetId:String = assetXML..id.toString();
				var spawnPoint:Point = new Point(294, 170);
				var newSubmarine:Submarine = new Submarine(this, assetId, spawnPoint, Math.random() * 2.0 + 0.4);
				mSubmarines.push(newSubmarine);			
//				newSubmarinelayer.addChild(newSubmarine);
			}
			mTextField.text = ""
			mSubmarinesloaded = true
//
//									for(var i = 0; i < 1; i++)
//			{
//			var	newindex = Math.floor(mSubmarines.length * Math.random())
//			newSubmarinelayer.addChild (mSubmarines [newindex]) 
//			}


		}	
		public function GotHoverers(e:Event):void
		{
			var dataXML:XML = new XML(e.target.data);
			
			// Parse the XML
			namespace atomenv = "http://www.w3.org/2005/Atom";
			use namespace atomenv;
			
			for each (var assetXML:XML in dataXML..asset)
			{
				var assetId:String = assetXML..id.toString();
				var spawnPoint:Point = new Point(150, Math.random() * mHeighthoverer +80);
				var newHoverer:Hoverer = new Hoverer(this, assetId, spawnPoint, Math.random() * 2.0 + 0.4);
				mHoverers.push(newHoverer);			
//				newHovererlayer.addChild(newHoverer);
			}
			mTextField.text = ""
			mHoverersloaded = true

	//		for(var i = 0; i < 1; i++)
//			{
//			var	newindex = Math.floor(mHoverers.length * Math.random())
//			newHovererlayer.addChild (mHoverers [newindex]) 
//			}

		}	
			public function GotStarfishrights(e:Event):void
		{
			var dataXML:XML = new XML(e.target.data);
			
			// Parse the XML
			namespace atomenv = "http://www.w3.org/2005/Atom";
			use namespace atomenv;
			
			for each (var assetXML:XML in dataXML..asset)
			{
				var assetId:String = assetXML..id.toString();
				var spawnPoint:Point = new Point(425,100);
				var newStarfishright:Starfishright = new Starfishright(this, assetId, spawnPoint, Math.random() * 2.0 + 0.4);
				mStarfishrights.push(newStarfishright);			
//				newStarfishrightlayer.addChild(newStarfishright);
			}
			mTextField.text = ""
			mStarfishrightsloaded = true

			//for(var i = 0; i < 1; i++)
//			{
//			var	newindex = Math.floor(mStarfishrights.length * Math.random())
//			newStarfishrightlayer.addChild (mStarfishrights [newindex]) 
//			}

		}
		public function GotStarfishlefts(e:Event):void
		{
			var dataXML:XML = new XML(e.target.data);
			
			// Parse the XML
			namespace atomenv = "http://www.w3.org/2005/Atom";
			use namespace atomenv;
			
			for each (var assetXML:XML in dataXML..asset)
			{
				var assetId:String = assetXML..id.toString();
				var spawnPoint:Point = new Point(150,200);
				var newStarfishleft:Starfishleft = new Starfishleft(this, assetId, spawnPoint, Math.random() * 2.0 + 0.4);
				mStarfishlefts.push(newStarfishleft);			
//				newStarfishleftlayer.addChild(newStarfishleft);
			}
			mTextField.text = ""
			mStarfishleftsloaded = true

			//for(var i = 0; i < 1; i++)
//			{
//			var	newindex = Math.floor(mStarfishlefts.length * Math.random())
//			newStarfishleftlayer.addChild (mStarfishlefts [newindex]) 
//			}

		}
		public function GotBigfishs(e:Event):void
		{
			var dataXML:XML = new XML(e.target.data);
			
			// Parse the XML
			namespace atomenv = "http://www.w3.org/2005/Atom";
			use namespace atomenv;
			
			for each (var assetXML:XML in dataXML..asset)
			{
				var assetId:String = assetXML..id.toString();
				var spawnPoint:Point = new Point(Math.random() * mWidthbigfish +256, Math.random() * 50 + 70);
				var newBigfish:Bigfish = new Bigfish(this, assetId, spawnPoint, Math.random() * 2.0 + 0.4);
				mBigfishs.push(newBigfish);			
//				newBigfishlayer.addChild(newBigfish);
			}
			mTextField.text = ""
			mBigfishsloaded = true

			//for(var i = 0; i < 1; i++)
//			{
//			var	newindex = Math.floor(mBigfishs.length * Math.random())
//			newBigfishlayer.addChild (mBigfishs [newindex]) 
//			}


		}
			public function GotFishs(e:Event):void
		{
			var dataXML:XML = new XML(e.target.data);
			
			// Parse the XML
			namespace atomenv = "http://www.w3.org/2005/Atom";
			use namespace atomenv;
			
			for each (var assetXML:XML in dataXML..asset)
			{
				var assetId:String = assetXML..id.toString();
				var name:String = assetXML..name.toString();
				var spawnPoint:Point = new Point(Math.random() * mWidthfish +128, Math.random() * 150 + 90);
				var newFish:Fish = new Fish(this, assetId, spawnPoint, name, Math.random() * 2.0 + 0.4);
				mFishs.push(newFish);			
//				newFishslayer.addChild(newFish);
			}
			
			
			mTextField.text = ""
			mFishsloaded = true
			/*for(var i = 0; i < 3; i++)
			{
			var	newfishindex = Math.floor(mFishs.length * Math.random())
			newFishslayer.addChild (mFishs [newfishindex]) 
			}*/

		}		
		public function GotFeeders(e:Event):void
		{
			var dataXML:XML = new XML(e.target.data);
			
			// Parse the XML
			namespace atomenv = "http://www.w3.org/2005/Atom";
			use namespace atomenv;
			
			for each (var assetXML:XML in dataXML..asset)
			{
				var assetId:String = assetXML..id.toString();
				var spawnPoint:Point = new Point(Math.random() * mWidthfeeder + 128, 305);
				var newFeeder:Feeder = new Feeder(this, assetId, spawnPoint, Math.random() * 2.0 + 0.4);
				mFeeders.push(newFeeder);			
//				newFeederlayer.addChild(newFeeder);
			}
			mTextField.text = ""
			mFeedersloaded = true
			//for(var i = 0; i < 1; i++)
//			{
//			var	newindex = Math.floor(mFeeders.length * Math.random())
//			newFeederlayer.addChild (mFeeders [newindex]) 
//			}
		}	
				 
		public var mPNGsToLoad:Array = new Array();
		
		public function UpdatePNGloader (e:Event):void
		{
			if (mPNGsToLoad.length == 0 )
			{
				return;
			}
			
			var first = mPNGsToLoad [0]
			
			if (first.mLoaded == true)
			{
				mPNGsToLoad.shift()
			}
			
			else 
			if (first.mLoading == true)
			{
				// loading please wait
			}
			
			else
			{
				first.LoadPNG()
			}
			
		}
		
			var	mLoadedScene = false
		public function CheckIfSporecastsLoaded(e:Event):void
		{
			if (mRock2sloaded &&
		 	mRocksloaded &&
			mCastlesloaded &&
			mFishsloaded && 
			mStarfishleftsloaded && 
			mStarfishrightsloaded &&
			mBigfishsloaded &&
			mFeedersloaded &&
			mSubmarinesloaded &&
			mHoverersloaded &&
			mLoadedScene == false)
			{
				LoadTheScene()
				mLoadedScene = true;
			}
			
		}
		public function ClearLayer(layer, objectArray, count): void
		{
			while(layer.numChildren > 0)
			{
				layer.removeChildAt(0);
			}
			
			for(var i = 0; i < count; i++)
			{
				var	newfishindex = Math.floor(objectArray.length * Math.random())
				layer.addChild (objectArray[newfishindex]) 
				mPNGsToLoad.push(objectArray[newfishindex]);	
			}
		}
		
		public function LoadTheScene():void
		{
			ClearLayer(newRock2layer, mRock2s, 3)
			ClearLayer(newRocklayer, mRocks, 3 )
			ClearLayer(newCastlelayer, mCastles, 1)
			ClearLayer(newSubmarinelayer, mSubmarines, 1)
			ClearLayer(newHovererlayer, mHoverers, 1)
			ClearLayer(newStarfishleftlayer, mStarfishlefts, 1)
			ClearLayer(newStarfishrightlayer, mStarfishrights, 1)
			ClearLayer(newBigfishlayer, mBigfishs, 1)
			ClearLayer(newFishslayer, mFishs, 5)
			ClearLayer(newFeederlayer, mFeeders, 1)
		}
		
					
//		public function UpdateRock2(e:Event):void
//		{
//			for(var i = 0; i < mRock2s.length; i++)
//			{
//				if(mRock2s[i].mLoaded)
//				{
//					continue;
//				}
//				
//				if(mRock2s[i].mLoading)
//				{
//					// only queue load one at a time
//					break;
//				}
//				mRock2s[i].LoadPNG();
//			}
//		}
			public function UpdateCastle(e:Event):void
		{
			for(var i = 0; i < mCastles.length; i++)
			{
				if(mCastles[i].mLoaded)
				{
					continue;
				}
				
				if(mCastles[i].mLoading)
				{
					// only queue load one at a time
					break;
				}
				mCastles[i].LoadPNG();
			}
		}
		public function UpdateRock(e:Event):void
		{
			for(var i = 0; i < mRocks.length; i++)
			{
				if(mRocks[i].mLoaded)
				{
					continue;
				}
				
				if(mRocks[i].mLoading)
				{
					// only queue load one at a time
					break;
				}
				mRocks[i].LoadPNG();
			}
		}
		
		public function UpdateSubmarine(e:Event):void
		{
			for(var i = 0; i < mSubmarines.length; i++)
			{
				if(mSubmarines[i].mLoaded)
				{
					continue;
				}
				
				if(mSubmarines[i].mLoading)
				{
					// only queue load one at a time
					break;
				}
				mSubmarines[i].LoadPNG();
			}
		}
		public function UpdateHoverer(e:Event):void
		{
			for(var i = 0; i < mHoverers.length; i++)
			{
				if(mHoverers[i].mLoaded)
				{
					continue;
				}
				
				if(mHoverers[i].mLoading)
				{
					// only queue load one at a time
					break;
				}
				mHoverers[i].LoadPNG();
			}
		}
		public function UpdateStarfishright(e:Event):void
		{
			for(var i = 0; i < mStarfishrights.length; i++)
			{
				if(mStarfishrights[i].mLoaded)
				{
					continue;
				}
				
				if(mStarfishrights[i].mLoading)
				{
					// only queue load one at a time
					break;
				}
				mStarfishrights[i].LoadPNG();
			}
		}
		public function UpdateStarfishleft(e:Event):void
		{
			for(var i = 0; i < mStarfishlefts.length; i++)
			{
				if(mStarfishlefts[i].mLoaded)
				{
					continue;
				}
				
				if(mStarfishlefts[i].mLoading)
				{
					// only queue load one at a time
					break;
				}
				mStarfishlefts[i].LoadPNG();
			}
		}
		public function UpdateBigfish(e:Event):void
		{
			for(var i = 0; i < mBigfishs.length; i++)
			{
				if(mBigfishs[i].mLoaded)
				{
					continue;
				}
				
				if(mBigfishs[i].mLoading)
				{
					// only queue load one at a time
					break;
				}
				mBigfishs[i].LoadPNG();
			}
		}
		public function UpdateFish(e:Event):void
		{
			for(var i = 0; i < mFishs.length; i++)
			{
				if(mFishs[i].mLoaded)
				{
					continue;
				}
				
				if(mFishs[i].mLoading)
				{
					// only queue load one at a time
					break;
				}
				mFishs[i].LoadPNG();
			}
		}
		public function UpdateFeeder(e:Event):void
		{
			for(var i = 0; i < mFeeders.length; i++)
			{
				if(mFeeders[i].mLoaded)
				{
					continue;
				}
				
				if(mFeeders[i].mLoading)
				{
					// only queue load one at a time
					break;
				}
				mFeeders[i].LoadPNG();
			}
		}
		
		
		
	
		
		
		
		
		
	}
}